# core/bot.py
#
#

""" basic package for the program. """

__copyright__ = "Copyright 2014 B.H.J Thate"

## IMPORTS

from core.utils import get_name, short_date
from core.errors import RemoteDisconnect
from core.dispatch import Dispatcher
from core.defines import BLA, ENDC
from core.object import Object

from core import kernel, fleet

import logging
import socket
import time

## BOTS

class Bot(Dispatcher):

    """ Base Bot class. """

    def __init__(zelf, *args, **kwargs):
        Dispatcher.__init__(zelf, *args, **kwargs)
        zelf.type = get_name(zelf).split(".")[-1]
        zelf.channels = []
        zelf.waiting = True
        zelf._started = time.time()
        zelf._last = time.time()
        if "channel" in zelf and zelf.channel not in zelf.channels: zelf.channels.append(zelf.channel)
        if zelf not in fleet: fleet.append(zelf)

    def _raw(zelf, *args, **kwargs): pass

    def join_channels(zelf, *args, **kwargs):
        """ join channels.  """ 
        for channel in zelf.channels: zelf.join(channel)

    def join(zelf, *args, **kwargs): pass

    def exit(zelf, *args, **kwargs):
        """ shutdown a bot. """
        zelf._status = ""

    def start(zelf, *args, **kwargs):
        """ start a bot. """
        zelf._status = "running"
        zelf.connect()
        current = None
        while zelf._status:
             event = zelf.get_event()
             if not zelf._status: break
             if event: 
                 current = zelf.put(zelf.handle_event, event)
                 zelf._last = time.time()
             if zelf._status == "once": event.wait() ; break
             time.sleep(0.05)
        if current: current._status = "" ; current.wait()
        zelf.ready()
 
    def get_prompt(zelf, *args, **kwargs):
        """ return a prompt. """
        return ""

    def get_event(zelf, *args, **kwargs):
        """ return an event. """
        o =  Object()
        o.type = "Event"
        o._target = zelf
        return o

    def connect(zelf, *args, **kwargs):
        """ connect to server. """
        pass

    def announce(zelf, *args, **kwargs):
        """ announce on channels. """
        for channel in zelf.channels: kernel.workers.put(zelf.say, channel, args[0])
                   
    def say(zelf, *args, **kwargs): raise NotImplemented()

    def cmnd(zelf, *args, **kwargs):
        """ run a command with provided string. """
        o = Object()
        o._target = zelf
        o.txt = args[0]
        return zelf.handle_event(o)

    def handle_event(zelf, *args, **kwargs):
        event = args[0]
        cmnd = event.get_cmnd()
        res = kernel.cmnds.dispatch(cmnd, *args, **kwargs)
        if not res: res = kernel.ctrl.dispatch(cmnd, *args, **kwargs)
        return res
         
## TESTBOT

class TestBot(Bot):

    """ Bot used in unittests. """

    channel = "#test"

    def __init__(zelf, *args, **kwargs):
        Bot.__init__(zelf, *args, **kwargs)
        zelf.results = []

    def _raw(zelf, *args, **kwargs):
        zelf.results.append(args[0])

    def check(zelf, *args, **kwargs):
        if args[0] in zelf.results: return True
